#include "../src/DepthSearchAI.hpp"
#include "../src/NaiveAI.hpp"
#include "../src/PokemonAI.hpp"
#include "../src/RandomAI.hpp"
#include "Core.hpp"

export void pkmnlibai_PokemonAI_Delete(PkmnLibAI::PokemonAI* p) { delete p; }

export u8 pkmnlibai_PokemonAI_GetChoice(CreatureLib::Battling::BaseTurnChoice*& out, PkmnLibAI::PokemonAI* p,
                                        PkmnLib::Battling::Battle* battle, PkmnLib::Battling::Pokemon* user) {
    Try(out = p->GetChoice(battle, user);)
}

export PkmnLibAI::RandomAI* pkmnlibai_RandomAI_Create() { return new PkmnLibAI::RandomAI(); }
export PkmnLibAI::NaiveAI* pkmnlibai_NaiveAI_Create() { return new PkmnLibAI::NaiveAI(); }
export PkmnLibAI::DepthSearchAI* pkmnlibai_DepthSearchAI_Create() { return new PkmnLibAI::DepthSearchAI(); }